$!-----------------------------------------------------------------------------
$! BUILD_VWCMS.COM
$!
$! Build the VWCMS executable.
$!
$! Build is to VMS V6.2 (for the C-RTL).
$! To build on earlier comment-out "VWCMS_VMS_V62 = ..." below.
$!
$! P1-4 == BUILD, COMPILE, LINK or empty (builds)
$!
$! 05-JAN-2007  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ VWCMS_VMS_V62 = "VWCMS_VMS_V62,"
$!
$ IF P1 .EQS. "DIST"
$ THEN
$!   (distribution build - not used on your average site)
$    @BUILD_VWCMS
$    EXIT   
$ ENDIF
$!
$!(marshal the build parameters)
$ BUILD = "BUILD"
$ IF P1 .EQS. "BUILD" THEN BUILD = P1
$ IF P2 .EQS. "BUILD" THEN BUILD = P2
$ IF P3 .EQS. "BUILD" THEN BUILD = P3
$ IF P4 .EQS. "BUILD" THEN BUILD = P4
$ IF P1 .EQS. "COMPILE" THEN BUILD = P1
$ IF P2 .EQS. "COMPILE" THEN BUILD = P2
$ IF P3 .EQS. "COMPILE" THEN BUILD = P3
$ IF P4 .EQS. "COMPILE" THEN BUILD = P4
$ IF P1 .EQS. "LINK" THEN BUILD = P1
$ IF P2 .EQS. "LINK" THEN BUILD = P2
$ IF P3 .EQS. "LINK" THEN BUILD = P3
$ IF P4 .EQS. "LINK" THEN BUILD = P4
$ JUST = ""
$ IF F$ELEMENT(0,":",P1) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P1)
$ IF F$ELEMENT(0,":",P2) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P2)
$ IF F$ELEMENT(0,":",P3) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P3)
$ IF F$ELEMENT(0,":",P4) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P4)
$!
$ DATETIME = F$TIME()
$ IF F$EXTRACT(0,1,DATETIME) .EQS. " " THEN DATETIME = F$EXTRACT(1,99,DATETIME)
$!
$ ON CONTROLY THEN EXIT 44
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""VWCMS"" for ""''F$GETSYI("ARCH_NAME")'"""
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ VMS_VERSION = F$GETSYI("VERSION")
$ VMS_VERSION = F$INTEGER(F$EXTRACT(1,1,VMS_VERSION)) * 10 +-
                F$INTEGER(F$EXTRACT(3,1,VMS_VERSION))
$!
$ IF F$TYPE(VWCMS_VMS_V62) .EQS. "" THEN VWCMS_VMS_V62 = ""
$!
$ CC_DEFINES = "/DEFINE=('VWCMS_VMS_V62'BUILD_DATETIME=""""""''DATETIME'"""""")"
$!
$ LINK_OPTIONS = F$SEARCH("VWCMS_''ARCH_NAME'.OPT")
$ IF LINK_OPTIONS .NES. "" -
     THEN LINK_OPTIONS = "," + F$ELEMENT(0,";",LINK_OPTIONS) + "/OPTIONS"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE/DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ IF JUST .EQS. "" .AND. BUILD .NES. "LINK"
$ THEN
$    DELETE = "DELETE/LOG"
$    DELETE 'OBJECT_DIR'*.OBJ;*
$ ENDIF
$!
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL /INC=[]"
$ ELSE
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL /INC=[] "
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. BUILD .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$!(compile vwcms components)
$ IF JUST .NES. "" THEN GOTO 'JUST'
$ AGO:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' ago.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ AUTHVMS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' authvms.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CGILIB:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' CGILIB.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CONFIG:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' config.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ COMMENT:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' comment.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CONTENT:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' content.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ COOKIE:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' cookie.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ DATA:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' data.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ FEEDBACK:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' feedback.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ FORM:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' form.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ LOGIN:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' login.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MANAGE:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' manage.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ OTHER:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' other.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ RC4:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' RC4.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ REGEX:
$ REGEX_DEFINES = CC_DEFINES - ")" + "," + "STDC_HEADERS,REGEX_MALLOC)"
$ CC 'CC_OPTIONS' 'REGEX_DEFINES' /OBJ='OBJECT_DIR' regex
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SEARCH:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' search.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SENDMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' sendmail.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SHOWLOCAL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' showlocal.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ STRPTIME:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' strptime.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SYNOPSIS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' synopsis.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ TAG:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' tag.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ TEMPLATE:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' template.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ TICKET:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' ticket.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$ VWCMS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' vwcms.c
$ IF JUST .NES. "" THEN GOTO END_JUST
$!
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. BUILD .EQS. "LINK"
$ THEN
$    LINK_OPTIONS = ""
$    SET NOON
$    SET VERIFY
$!   (linking vanilla version)
$ LINK/NOTRACE/EXECUTABLE='OBJECT_DIR'VWCMS.EXE -
  'OBJECT_DIR'CGILIB,ago,authvms,config,comment,content,cookie,data,-
  feedback,form,login,manage,other,rc4,regex,search,sendmail,showlocal,-
  strptime,synopsis,tag,template,ticket,vwcms
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$ PURGE/NOLOG 'OBJECT_DIR'
$ END_JUST:
$!'F$VERIFY(0)
$!
$!-----------------------------------------------------------------------------
